using System;
using Castle.Core;
using Castle.MicroKernel;
using Castle.Windsor;

namespace MonoCastleAnonResolveFail
{
	class MainClass
	{
		public static void Main (string[] args)
		{
			var arg = new { foo = "bar" };
			var container = new WindsorContainer ();

			try
			{
				var dict = new ReflectionBasedDictionaryAdapter (arg);
	            container.Resolve<MainClass> (dict);
			}
			catch (ComponentNotFoundException)
			{
				Console.WriteLine ("Success");
			}

			try
			{
				Console.WriteLine ("Hello World!");
	            container.Resolve<MainClass> (arg);
			}
			catch (ComponentNotFoundException)
			{
				Console.WriteLine ("Success");
			}
			finally {
				Console.WriteLine ("Goodbye!");
			}
		}
	}
}
